#include <sys/queue.h>

/* structure to hold all of the useful bits of the scanner .. */

struct myctx {
	int             flags;	/* scanner type flags */
#define SCAN_FLAGS_ACTIVE	0x01
#define SCAN_FLAGS_PASSIVE	0x02
	u_int           dport;	/* last scanned port */
	struct addr     src;	/* source address */
	struct addr     dst;	/* target address */
	pcap_t         *p;	/* pcap handle */
	ip_t           *ip;	/* ip send handle */
	rand_t         *rand;	/* PRNG */
	int             dl_len;	/* datalink layer hdr len */
	struct event    send_ev;/* send event */
	struct event    recv_ev;/* receive event */
	struct timeval  tv;	/* timeout values */
	char           *osfile;	/* OS fingerprint file */
};

struct jscan_pkt {
	union {
		struct ip_hdr   ip;
	} pkt_hdr_i;
	union {
		struct tcp_hdr  tcp;
	} pkt_hdr_t;
};

/* list of seen hosts and their ports. */

TAILQ_HEAD(tailhead, entry) head;
struct tailhead *headp;

struct entry {
	struct addr     	host;	/* the host we saw */
	u_int           	port;	/* what TCP port */
	time_t          	seen;	/* when we saw it */
        TAILQ_ENTRY(entry) 	entries;	/* next entry */
};
